## rawtherapee-gtk2 5.0.1

=== CMakeLists.txt ===
if (WIN32)
  cmake_minimum_required(VERSION 2.8.4)
else (WIN32)
  cmake_minimum_required(VERSION 2.6)
endif (WIN32)

# must stay before the 'project' command
if(${CMAKE_EXTRA_GENERATOR} MATCHES "Eclipse CDT4")
  set(CMAKE_CXX_COMPILER_ARG1 "-std=c++11" CACHE STRING "C++ version for eclipse" FORCE)
  # users building with Eclipse should set CMAKE_ECLIPSE_VERSION through the command line to their current version of Eclipse
  #set(CMAKE_ECLIPSE_VERSION "4.6.0" CACHE STRING "Eclipse version" FORCE)
endif()

PROJECT(RawTherapee)

# the default target is 'Debug'
if (CMAKE_BUILD_TYPE STREQUAL "")
  set (CMAKE_BUILD_TYPE Debug CACHE STRING "One of: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif ()

string (TOUPPER ${CMAKE_BUILD_TYPE} UPPER_CMAKE_BUILD_TYPE)

# Set required C and C++ standards and check GCC version
SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.9")
  message(FATAL_ERROR "Building RawTherapee requires using GCC version 4.9 or higher!")
endif()

# We might want to build using the old C++ ABI, even when using a new GCC version
if (USE_OLD_CXX_ABI)
  add_definitions (-D_GLIBCXX_USE_CXX11_ABI=0)
endif()

if (UPPER_CMAKE_BUILD_TYPE STREQUAL "DEBUG")
  add_definitions (-D_DEBUG)
else ()
  add_definitions (-DNDEBUG)
  add_definitions (-D_DNDEBUG)
endif ()

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")

# Examples: "" = ~/.config/RawTherapee, "latesttag" = ~/.config/RawTherapee4.2, "_testing" = ~/.config/RawTherapee_testing
set (CACHE_NAME_SUFFIX "" CACHE STRING "RawTherapee's cache folder suffix")

# By default, we don't use specific processor target, so  PROC_TARGET_NUMBER is set to 0. If can specify other values to select specific
# processor targets, which list can be found in ProcessorTargets.cmake.
set (PROC_TARGET_NUMBER 0 CACHE STRING "Selected target processor from the list above (taken from ProcessorTargets.cmake)")

# The following line set special compilation flags for RTEngine, and will be added to CMAKE_CXX_FLAGS
set (RTENGINE_CXX_FLAGS "" CACHE STRING "Special compilation flags for RTEngine")

#loading the processor targets list
include (ProcessorTargets.cmake)
set (PROC_LABEL "undefined" CACHE STRING "Target processor label, unused if PROC_TARGET_NUMBER = 0 or 2")
set (PROC_FLAGS "" CACHE STRING "Target processor related build/link flags")
if ((NOT(PROC_TARGET_NUMBER EQUAL 0)) AND (NOT(PROC_TARGET_NUMBER EQUAL 2)))
	set (PROC_LABEL ${PROC_TARGET_${PROC_TARGET_NUMBER}_LABEL})
endif ()
if (NOT(PROC_TARGET_NUMBER EQUAL 0))
	set (PROC_FLAGS ${PROC_TARGET_${PROC_TARGET_NUMBER}_FLAGS})
endif ()
if (UNIX AND PROC_LABEL STREQUAL "undefined")
    execute_process(COMMAND uname -p OUTPUT_STRIP_TRAILING_WHITESPACE OUTPUT_VARIABLE cpu)
    if ("${cpu}" STREQUAL "unknown")
        set(PROC_LABEL "${CMAKE_SYSTEM_PROCESSOR}")
    else ()
        set (PROC_LABEL "${cpu}")
    endif ()
endif ()

# if it exists, the PROC_FORCED_LABEL value is loaded in PROC_LABEL to override the one of ProcessorTargets
if (DEFINED PROC_FORCED_LABEL)
  set (PROC_LABEL ${PROC_FORCED_LABEL})
endif (DEFINED PROC_FORCED_LABEL)

# adding the proc flags to the build flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PROC_FLAGS}")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${PROC_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${PROC_FLAGS}")

#stop compile on typos like std:swap (missing colon will be detected as unused label)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=unused-label")

if (WIN32)
    # we additionnally look in the MinGW path first then in the Gtkmm path,
    # so if you wish to build some dependant library, you have to install them in MinGW to use them
    set(CMAKE_PREFIX_PATH $ENV{MINGW_BASEPATH} $ENV{GTKMM_BASEPATH} CACHE STRING "Additional search paths")
endif (WIN32)

if (APPLE)
    if (CMAKE_CXX_COMPILER MATCHES "g\\+\\+-mp-4.[5-8]" OR
        CMAKE_CXX_COMPILER_ARG1 MATCHES "g\\+\\+-mp-4.[5-8]")
        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /usr/lib/libstdc++.6.dylib")
        message (STATUS "CMAKE_CXX_COMPILER is MacPorts GCC.\n   CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS}")
    endif ()
endif (APPLE)

option(USE_EXPERIMENTAL_LANG_VERSIONS "Build RT with -std=c++0x" OFF)
option (BUILD_SHARED "Build rawtherapee with shared libraries" OFF)
option (WITH_BZIP "Build with Bzip2 support" ON)
option (WITH_MYFILE_MMAP "Build using memory mapped file" ON)
option (WITH_LTO "Build with link-time optimizations" OFF)
option (WITH_SAN "Build with run-time sanitizer" OFF)
option (WITH_PROF "Build with profiling instrumentation" OFF)
option (OPTION_OMP "Build with OpenMP support" ON)
option (STRICT_MUTEX "True (recommended): MyMutex will behave like POSIX Mutex; False: MyMutex will behave like POSIX RecMutex; Note: forced to ON for Debug builds" ON)
option (TRACE_MYRWMUTEX "Trace RT's custom R/W Mutex (Debug builds only); redirecting std::out to a file is strongly recommended!" OFF)
option (AUTO_GDK_FLUSH "Use gdk_flush on all gdk_thread_leave other than the GUI thread; set it ON if you experience X Server warning/errors" OFF)

# set install directories
if (WIN32 OR APPLE)
    set (BUILD_BUNDLE ON FORCE)
endif(WIN32 OR APPLE)

if (NOT DEFINED BUNDLE_BASE_INSTALL_DIR)
    set (BUNDLE_BASE_INSTALL_DIR "${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}")
endif (NOT DEFINED BUNDLE_BASE_INSTALL_DIR)

if (BUILD_BUNDLE)
    set (BINDIR .)
    set (CMAKE_INSTALL_PREFIX "${BUNDLE_BASE_INSTALL_DIR}")
endif (BUILD_BUNDLE)

if (NOT DEFINED BINDIR)
    set (BINDIR "${CMAKE_INSTALL_PREFIX}/bin")
endif (NOT DEFINED BINDIR)

if (NOT DEFINED DATADIR)
    if (BUILD_BUNDLE)
        set (DATADIR .)
    else (BUILD_BUNDLE)
        set (DATADIR "${CMAKE_INSTALL_PREFIX}/share/rawtherapee")
    endif (BUILD_BUNDLE)
endif (NOT DEFINED DATADIR)

if (NOT DEFINED LIBDIR)
    if (BUILD_BUNDLE)
        set (LIBDIR .)
    else (BUILD_BUNDLE)
        # Respect CMAKE_INSTALL_LIBDIR if set
        if (DEFINED CMAKE_INSTALL_LIBDIR)
	    if (IS_ABSOLUTE "${LIBDIR}")
            	set (LIBDIR "${CMAKE_INSTALL_LIBDIR}")
	    else (IS_ABSOLUTE "${LIBDIR}")
		set (LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
	    endif (IS_ABSOLUTE "${LIBDIR}")
        else (DEFINED CMAKE_INSTALL_LIBDIR)
            set (LIBDIR "${CMAKE_INSTALL_PREFIX}/lib")
        endif (DEFINED CMAKE_INSTALL_LIBDIR)
    endif (BUILD_BUNDLE)
endif (NOT DEFINED LIBDIR)

if (NOT DEFINED DOCDIR)
    if (BUILD_BUNDLE)
        set (DOCDIR ./doc)
    else (BUILD_BUNDLE)
        set (DOCDIR "${CMAKE_INSTALL_PREFIX}/share/doc/rawtherapee")
    endif (BUILD_BUNDLE)
endif (NOT DEFINED DOCDIR)

if (NOT DEFINED CREDITSDIR)
    if (BUILD_BUNDLE)
        set (CREDITSDIR .)
    else (BUILD_BUNDLE)
        set (CREDITSDIR "${CMAKE_INSTALL_PREFIX}/share/doc/rawtherapee")
    endif (BUILD_BUNDLE)
endif (NOT DEFINED CREDITSDIR)

if (NOT DEFINED LICENCEDIR)
    if (BUILD_BUNDLE)
        set (LICENCEDIR .)
    else (BUILD_BUNDLE)
        set (LICENCEDIR "${CMAKE_INSTALL_PREFIX}/share/doc/rawtherapee")
    endif (BUILD_BUNDLE)
endif (NOT DEFINED LICENCEDIR)

if (NOT DEFINED DESKTOPDIR)
    if (UNIX)
        set (DESKTOPDIR "${CMAKE_INSTALL_PREFIX}/share/applications")
    endif (UNIX)
endif (NOT DEFINED DESKTOPDIR)

if (NOT DEFINED ICONSDIR)
    if (UNIX)
        set (ICONSDIR "${CMAKE_INSTALL_PREFIX}/share/icons")
    endif (UNIX)
endif (NOT DEFINED ICONSDIR)

if (NOT DEFINED APPDATADIR)
    if (UNIX)
        set (APPDATADIR "${CMAKE_INSTALL_PREFIX}/share/appdata")
    endif (UNIX)
endif (NOT DEFINED APPDATADIR)

# non-bundle builds has to use absolute paths
if (NOT BUILD_BUNDLE AND
    NOT (IS_ABSOLUTE "${BINDIR}" AND IS_ABSOLUTE "${DATADIR}" AND IS_ABSOLUTE "${LIBDIR}" AND
    IS_ABSOLUTE "${DOCDIR}" AND IS_ABSOLUTE "${CREDITSDIR}" AND IS_ABSOLUTE "${LICENCEDIR}"))
    message (FATAL_ERROR "The paths has to be absolute or use -DBUILD_BUNDLE=ON")
endif ()

# MyMutex
if (STRICT_MUTEX OR UPPER_CMAKE_BUILD_TYPE STREQUAL "DEBUG")
    add_definitions (-DSTRICT_MUTEX=1)
else (STRICT_MUTEX OR UPPER_CMAKE_BUILD_TYPE STREQUAL "DEBUG")
    add_definitions (-DSTRICT_MUTEX=0)
endif (STRICT_MUTEX OR UPPER_CMAKE_BUILD_TYPE STREQUAL "DEBUG")

# MyRWMutex
if (TRACE_MYRWMUTEX)
    add_definitions (-DTRACE_MYRWMUTEX=1)
else (TRACE_MYRWMUTEX)
    add_definitions (-DTRACE_MYRWMUTEX=0)
endif (TRACE_MYRWMUTEX)

if (AUTO_GDK_FLUSH)
    add_definitions (-DAUTO_GDK_FLUSH=1)
else (AUTO_GDK_FLUSH)
    add_definitions (-DAUTO_GDK_FLUSH=0)
endif (AUTO_GDK_FLUSH)

# check for libraries
find_package(PkgConfig)
pkg_check_modules (GTK     REQUIRED gtk+-2.0>=2.12)
pkg_check_modules (GLIB2   REQUIRED glib-2.0>=2.16)
pkg_check_modules (GLIBMM  REQUIRED glibmm-2.4>=2.16)
pkg_check_modules (GTKMM   REQUIRED gtkmm-2.4>=2.22)
pkg_check_modules (GIO     REQUIRED gio-2.0>=2.16)
pkg_check_modules (GIOMM   REQUIRED giomm-2.4>=2.12)
pkg_check_modules (GTHREAD REQUIRED gthread-2.0>=2.16)
pkg_check_modules (GOBJECT REQUIRED gobject-2.0>=2.16)
pkg_check_modules (SIGC    REQUIRED sigc++-2.0)
# NOTE: The new mechanism has been tested with BUILD_SHARED = OFF
if (WIN32)
    add_definitions (-DWIN32)
    add_definitions (-D_WIN32)
    if (MINGW)
        add_definitions (-D__MINGW32__)
    endif (MINGW)
	if (CMAKE_SIZEOF_VOID_P EQUAL 4)
        add_definitions (-DWINVER=0x0501)
    endif (CMAKE_SIZEOF_VOID_P EQUAL 4)
    set (EXTRA_LIB "-lws2_32 -lshlwapi")
endif (WIN32)
# you may need lcms v1.xx for older version : pkg_check_modules (LCMS REQUIRED lcms<=1.99)
pkg_check_modules (LCMS REQUIRED lcms2)
find_package (EXPAT REQUIRED expat>=2.0)
pkg_check_modules (FFTW3F REQUIRED fftw3f)
pkg_check_modules (IPTCDATA REQUIRED libiptcdata)
find_package (JPEG REQUIRED)
find_package (PNG REQUIRED)
find_package (TIFF REQUIRED)
find_package (ZLIB REQUIRED)

# link witz bzip
if (WITH_BZIP)
  find_package(BZip2)
  if (BZIP2_FOUND)
    add_definitions (-DBZIP_SUPPORT)
    set (EXTRA_INCDIR ${BZIP2_INCLUDE_DIR})
    set (EXTRA_LIB ${EXTRA_LIB} ${BZIP2_LIBRARIES})
  endif (BZIP2_FOUND)
endif (WITH_BZIP)

#Check for libcanberra-gtk (sound events on Linux)
if (UNIX AND (NOT APPLE))
    pkg_check_modules (CANBERRA-GTK REQUIRED libcanberra-gtk)
endif (UNIX AND (NOT APPLE))

if (WITH_MYFILE_MMAP)
	add_definitions (-DMYFILE_MMAP)
endif (WITH_MYFILE_MMAP)

if (WITH_LTO)
    SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -flto")
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
    SET (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -flto")
endif (WITH_LTO)

if (WITH_SAN)
    SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=${WITH_SAN}")
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=${WITH_SAN}")
    SET (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=${WITH_SAN}")
endif (WITH_SAN)

if (WITH_PROF)
    SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
    SET (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
endif (WITH_PROF)

if (OPTION_OMP)
    find_package(OpenMP)
    if (OPENMP_FOUND)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} -Werror=unknown-pragmas")
    endif (OPENMP_FOUND)
endif (OPTION_OMP)

# find out whether we are building out of source
get_filename_component(ABS_SOURCE_DIR "${PROJECT_SOURCE_DIR}" ABSOLUTE)
get_filename_component(ABS_BINARY_DIR "${CMAKE_BINARY_DIR}" ABSOLUTE)
set (OUT_OF_SOURCE_BUILD TRUE)
if (ABS_SOURCE_DIR STREQUAL ABS_BINARY_DIR)
    set (OUT_OF_SOURCE_BUILD FALSE)
    message (WARNING "You are performing an in-source build. This is discouraged. For an explanation and the advantages of out-of-source builds, please refer to http://www.cmake.org/Wiki/CMake_FAQ#What_is_an_.22out-of-source.22_build.3F")
endif ()

# XXX remove files triggering the below check to prevent every developer from

=== rtdata/CMakeLists.txt ===

file (GLOB LANGUAGEFILES "languages/*")
file (GLOB SOUNDFILES "sounds/*")
file (GLOB INPUTICCFILES "iccprofiles/input/*")
file (GLOB OUTPUTICCFILES "iccprofiles/output/*")
file (GLOB DCPFILES "dcpprofiles/*")
file (GLOB FONTS "fonts/*")
set (PROFILESDIR "profiles")
# THEMEDIR includes subfolders for image resources for some themes; doing the normal glob won't work.
set (THEMEDIR "themes")
set (IMAGESDIR "images")

if (WIN32)
    set(OPTIONSFILE "options/options.win")
elseif (APPLE)
    set(OPTIONSFILE "options/options.osx")
else (WIN32)
    set(OPTIONSFILE "options/options.lin")
endif (WIN32)

if (WIN32)
    install (FILES "${CMAKE_CURRENT_BINARY_DIR}/WindowsInnoSetup.iss" DESTINATION ${BINDIR})
endif (WIN32)

if (UNIX)
    configure_file ("${CMAKE_CURRENT_SOURCE_DIR}/icons/rawtherapee.desktop.in" "${CMAKE_CURRENT_BINARY_DIR}/rawtherapee.desktop")
    install (FILES "${CMAKE_CURRENT_BINARY_DIR}/rawtherapee.desktop" DESTINATION ${DESKTOPDIR})
    install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/icons/hi16-app-rawtherapee.png" DESTINATION "${ICONSDIR}/hicolor/16x16/apps" RENAME rawtherapee.png)
    install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/icons/hi24-app-rawtherapee.png" DESTINATION "${ICONSDIR}/hicolor/24x24/apps" RENAME rawtherapee.png)
    install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/icons/hi32-app-rawtherapee.png" DESTINATION "${ICONSDIR}/hicolor/32x32/apps" RENAME rawtherapee.png)
    install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/icons/hi48-app-rawtherapee.png" DESTINATION "${ICONSDIR}/hicolor/48x48/apps" RENAME rawtherapee.png)
    install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/icons/hi128-app-rawtherapee.png" DESTINATION "${ICONSDIR}/hicolor/128x128/apps" RENAME rawtherapee.png)
    install (FILES "${CMAKE_CURRENT_SOURCE_DIR}/icons/hi256-app-rawtherapee.png" DESTINATION "${ICONSDIR}/hicolor/256x256/apps" RENAME rawtherapee.png)
endif (UNIX)

install (FILES ${IMAGEFILES} DESTINATION "${DATADIR}/images")
install (FILES ${LANGUAGEFILES} DESTINATION "${DATADIR}/languages")
install (FILES ${SOUNDFILES} DESTINATION "${DATADIR}/sounds")
install (FILES ${INPUTICCFILES} DESTINATION "${DATADIR}/iccprofiles/input")
install (FILES ${OUTPUTICCFILES} DESTINATION "${DATADIR}/iccprofiles/output")
install (FILES ${DCPFILES} DESTINATION "${DATADIR}/dcpprofiles")
if (WIN32)
    install (FILES ${FONTS} DESTINATION "${DATADIR}/fonts")
endif (WIN32)
install (DIRECTORY ${PROFILESDIR} DESTINATION "${DATADIR}" FILES_MATCHING PATTERN "*.pp3")
install (DIRECTORY ${THEMEDIR} DESTINATION "${DATADIR}")
install (DIRECTORY ${IMAGESDIR} DESTINATION "${DATADIR}" FILES_MATCHING PATTERN "index.theme")
install (DIRECTORY ${IMAGESDIR} DESTINATION "${DATADIR}" FILES_MATCHING PATTERN "*.png")
install (FILES ${OPTIONSFILE} DESTINATION "${DATADIR}" PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ RENAME options)

if (WIN32)
  install (FILES "${PROJECT_SOURCE_DIR}/doc/manpage/rawtherapee.1" DESTINATION "${CMAKE_INSTALL_PREFIX}/share/man/man1")
endif (WIN32)

if (APPLE)
    # CMake escapes first item quote character. Do not remove 'DUMMY_VARIABLE='.
    set (MACOSX_BUNDLE_COMMAND  DUMMY_VARIABLE=
                                PROJECT_NAME="${PROJECT_NAME}"
                                PROJECT_SOURCE_DIR="${PROJECT_SOURCE_DIR}"
                                CMAKE_BUILD_TYPE="${CMAKE_BUILD_TYPE}"
                                GTK_PREFIX="${GTK_PREFIX}")
    if (PROC_BIT_DEPTH MATCHES 32)
        list (APPEND MACOSX_BUNDLE_COMMAND PROC_BIT_DEPTH=32)
    elseif (PROC_BIT_DEPTH MATCHES 64)
        list (APPEND MACOSX_BUNDLE_COMMAND PROC_BIT_DEPTH=64)
    endif (PROC_BIT_DEPTH MATCHES 32)
    list (APPEND MACOSX_BUNDLE_COMMAND sh "${PROJECT_SOURCE_DIR}/tools/osx/macosx_bundle.sh")

    add_custom_target(macosx_bundle
        COMMAND ${MACOSX_BUNDLE_COMMAND}
        WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
        COMMENT "Creating Mac OS X bundle")
endif (APPLE)

=== rtengine/CMakeLists.txt ===
include_directories (${EXTRA_INCDIR} ${GTHREAD_INCLUDE_DIRS} ${GOBJECT_INCLUDE_DIRS} ${GLIB2_INCLUDE_DIRS}
    ${GLIBMM_INCLUDE_DIRS} ${IPTCDATA_INCLUDE_DIRS} ${LCMS_INCLUDE_DIRS} ${EXPAT_INCLUDE_DIRS} ${FFTW3F_INCLUDE_DIRS}
    ${GTKMM_INCLUDE_DIRS} ${GTK_INCLUDE_DIRS})
link_directories ("${PROJECT_SOURCE_DIR}/rtexif" ${EXTRA_LIBDIR} ${GTHREAD_LIBRARY_DIRS}
    ${GOBJECT_LIBRARY_DIRS} ${GLIB2_LIBRARY_DIRS} ${GLIBMM_LIBRARY_DIRS}
    ${IPTCDATA_LIBRARY_DIRS} ${LCMS_LIBRARY_DIRS} ${EXPAT_LIBRARY_DIRS} ${FFTW3F_LIBRARY_DIRS})

set (CAMCONSTSFILE "camconst.json")

set (RTENGINESOURCEFILES colortemp.cc curves.cc flatcurves.cc diagonalcurves.cc dcraw.cc iccstore.cc color.cc
    dfmanager.cc ffmanager.cc gauss.cc rawimage.cc image8.cc image16.cc imagefloat.cc imagedata.cc imageio.cc improcfun.cc init.cc dcrop.cc
    loadinitial.cc procparams.cc rawimagesource.cc demosaic_algos.cc shmap.cc simpleprocess.cc refreshmap.cc
    fast_demo.cc amaze_demosaic_RT.cc CA_correct_RT.cc cfa_linedn_RT.cc green_equil_RT.cc hilite_recon.cc expo_before_b.cc
    stdimagesource.cc myfile.cc iccjpeg.cc improccoordinator.cc pipettebuffer.cc coord.cc
    processingjob.cc rtthumbnail.cc utils.cc labimage.cc slicer.cc cieimage.cc
    iplab2rgb.cc ipsharpen.cc iptransform.cc ipresize.cc ipvibrance.cc
    imagedimensions.cc jpeg_ijg/jpeg_memsrc.cc jdatasrc.cc iimage.cc
    EdgePreservingDecomposition.cc cplx_wavelet_dec.cc FTblockDN.cc
    PF_correct_RT.cc previewimage.cc ipwavelet.cc
    dirpyr_equalizer.cc
    calc_distort.cc lcp.cc dcp.cc ipretinex.cc
    cJSON.c camconst.cc
    klt/convolve.cc klt/error.cc klt/klt.cc klt/klt_util.cc klt/pnmio.cc klt/pyramid.cc klt/selectGoodFeatures.cc
    klt/storeFeatures.cc klt/trackFeatures.cc klt/writeFeatures.cc
    clutstore.cc
    ciecam02.cc
    )

include_directories (BEFORE "${CMAKE_CURRENT_BINARY_DIR}")

add_library (rtengine ${RTENGINESOURCEFILES})
add_dependencies (rtengine UpdateInfo)

#It may be nice to store library version too
IF (BUILD_SHARED_LIBS)
    install (TARGETS rtengine DESTINATION ${LIBDIR})
ENDIF (BUILD_SHARED_LIBS)

set_target_properties (rtengine PROPERTIES COMPILE_FLAGS "${RTENGINE_CXX_FLAGS}")

target_link_libraries (rtengine rtexif ${EXTRA_LIB} ${GOBJECT_LIBRARIES} ${GTHREAD_LIBRARIES}
    ${GLIB2_LIBRARIES} ${GLIBMM_LIBRARIES} ${LCMS_LIBRARIES} ${EXPAT_LIBRARIES} ${FFTW3F_LIBRARIES} ${IPTCDATA_LIBRARIES}
    ${JPEG_LIBRARIES} ${PNG_LIBRARIES} ${TIFF_LIBRARIES} ${ZLIB_LIBRARIES})

install (FILES ${CAMCONSTSFILE} DESTINATION "${DATADIR}" PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

=== rtexif/CMakeLists.txt ===
add_library (rtexif rtexif.cc stdattribs.cc nikonattribs.cc canonattribs.cc pentaxattribs.cc fujiattribs.cc sonyminoltaattribs.cc olympusattribs.cc kodakattribs.cc)
add_dependencies (rtexif UpdateInfo)

IF (WIN32)
    set_target_properties (rtexif PROPERTIES COMPILE_FLAGS " -ffast-math -fexpensive-optimizations")
    include_directories (${EXTRA_INCDIR} ${GLIB2_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS}
        ${GTK_INCLUDE_DIRS} ${GTKMM_INCLUDE_DIRS})
    link_directories (. "${PROJECT_SOURCE_DIR}/rtexif" ${EXTRA_LIBDIR} ${GLIB2_LIBRARY_DIRS} ${GLIBMM_LIBRARY_DIRS}
        ${GTK_LIBRARY_DIRS} ${GTKMM_LIBRARY_DIRS})
    #set_target_properties (rth PROPERTIES LINK_FLAGS "-mwindows")
ELSE (WIN32)
    set_target_properties (rtexif PROPERTIES COMPILE_FLAGS " -ffast-math -fexpensive-optimizations -fPIC")
    include_directories (${EXTRA_INCDIR} ${GLIB2_INCLUDE_DIRS}
        ${GLIBMM_INCLUDE_DIRS} ${GTK_INCLUDE_DIRS} ${GTKMM_INCLUDE_DIRS})
    link_directories (${EXTRA_LIBDIR} ${GLIB2_LIBRARY_DIRS}
        ${GLIBMM_LIBRARY_DIRS} ${GTK_LIBRARY_DIRS} ${GTKMM_LIBRARY_DIRS})
ENDIF (WIN32)

include_directories (BEFORE "${CMAKE_CURRENT_BINARY_DIR}")

IF (BUILD_SHARED_LIBS)
    INSTALL(TARGETS rtexif DESTINATION ${LIBDIR})
ENDIF (BUILD_SHARED_LIBS)

=== rtgui/CMakeLists.txt ===

set (BASESOURCEFILES
    editwindow.cc batchtoolpanelcoord.cc paramsedited.cc cropwindow.cc previewhandler.cc previewwindow.cc navigator.cc indclippedpanel.cc previewmodepanel.cc filterpanel.cc
    exportpanel.cc cursormanager.cc rtwindow.cc renamedlg.cc recentbrowser.cc placesbrowser.cc filepanel.cc editorpanel.cc batchqueuepanel.cc
    ilabel.cc thumbbrowserbase.cc adjuster.cc filebrowserentry.cc filebrowser.cc filethumbnailbuttonset.cc
    cachemanager.cc cacheimagedata.cc shcselector.cc perspective.cc thresholdselector.cc thresholdadjuster.cc
    clipboard.cc thumbimageupdater.cc bqentryupdater.cc lensgeom.cc coloredbar.cc edit.cc coordinateadjuster.cc
    coarsepanel.cc cacorrection.cc  chmixer.cc blackwhite.cc
    resize.cc icmpanel.cc crop.cc shadowshighlights.cc
    impulsedenoise.cc dirpyrdenoise.cc epd.cc
    exifpanel.cc toolpanel.cc lensprofile.cc lockablecolorpicker.cc
    sharpening.cc vibrance.cc rgbcurves.cc  colortoning.cc
    whitebalance.cc   vignetting.cc gradient.cc pcvignette.cc rotate.cc distortion.cc
    crophandler.cc dirbrowser.cc
    curveeditor.cc curveeditorgroup.cc diagonalcurveeditorsubgroup.cc flatcurveeditorsubgroup.cc
    filecatalog.cc extprog.cc
    previewloader.cc rtimage.cc inspector.cc
    histogrampanel.cc history.cc  imagearea.cc
    imageareapanel.cc iptcpanel.cc labcurve.cc main.cc
    multilangmgr.cc mycurve.cc myflatcurve.cc mydiagonalcurve.cc options.cc retinex.cc
    preferences.cc profilepanel.cc saveasdlg.cc
    saveformatpanel.cc soundman.cc splash.cc
    thumbnail.cc tonecurve.cc toolbar.cc
    guiutils.cc threadutils.cc zoompanel.cc toolpanelcoord.cc
    thumbbrowserentrybase.cc batchqueueentry.cc
    batchqueue.cc lwbutton.cc lwbuttonset.cc
    batchqueuebuttonset.cc browserfilter.cc exiffiltersettings.cc
    profilestore.cc partialpastedlg.cc
    sensorbayer.cc sensorxtrans.cc preprocess.cc bayerpreprocess.cc bayerprocess.cc bayerrawexposure.cc xtransprocess.cc xtransrawexposure.cc
    darkframe.cc flatfield.cc rawcacorrection.cc rawexposure.cc wavelet.cc
    dirpyrequalizer.cc hsvequalizer.cc defringe.cc
    popupcommon.cc popupbutton.cc popuptogglebutton.cc sharpenedge.cc sharpenmicro.cc colorappearance.cc
    filmsimulation.cc prsharpening.cc)

include_directories (BEFORE "${CMAKE_CURRENT_BINARY_DIR}")

if (APPLE)
    find_package (MacIntegration REQUIRED)
    # At the time of writing Cmake has no module finder for gtkmacintegration so here we have it hard-coded, if installed via macports it should be in /opt/local/...
    set (EXTRA_LIB_RTGUI ${MacIntegration_LIBRARIES})
    set (EXTRA_INCDIR ${EXTRA_INCDIR} ${MacIntegration_INCLUDE_DIRS})
endif (APPLE)
if (WIN32)
    set (EXTRA_SRC windirmonitor.cc myicon.rc)
    set (EXTRA_LIB_RTGUI winmm)
    include_directories (${EXTRA_INCDIR} ${GLIB2_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS}
        ${GTK_INCLUDE_DIRS} ${GTKMM_INCLUDE_DIRS} ${GIO_INCLUDE_DIRS} ${GIOMM_INCLUDE_DIRS})
    link_directories (. "${PROJECT_SOURCE_DIR}/rtexif" ${EXTRA_LIBDIR} ${GLIB2_LIBRARY_DIRS} ${GLIBMM_LIBRARY_DIRS}
        ${GTK_LIBRARY_DIRS} ${GTKMM_LIBRARY_DIRS} ${GIO_LIBRARY_DIRS} ${GIOMM_LIBRARY_DIRS})
    #set_target_properties (rth PROPERTIES LINK_FLAGS "-mwindows")
else (WIN32)
    include_directories (${EXTRA_INCDIR} ${GLIB2_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS}
        ${GTK_INCLUDE_DIRS} ${GTKMM_INCLUDE_DIRS} ${GIO_INCLUDE_DIRS} ${GIOMM_INCLUDE_DIRS} ${IPTCDATA_INCLUDE_DIRS}
        ${LCMS_INCLUDE_DIRS} ${EXPAT_INCLUDE_DIRS} ${FFTW3F_LIBRARY_DIRS} ${GTHREAD_INCLUDE_DIRS} ${GOBJECT_INCLUDE_DIRS}
        ${CANBERRA-GTK_INCLUDE_DIRS})
    link_directories (${EXTRA_LIBDIR} ${GLIB2_LIBRARY_DIRS} ${GLIBMM_LIBRARY_DIRS}
        ${GTK_LIBRARY_DIRS} ${GTKMM_LIBRARY_DIRS} ${GIO_LIBRARY_DIRS} ${GIOMM_LIBRARY_DIRS} ${IPTCDATA_LIBRARY_DIRS}
        ${LCMS_LIBRARY_DIRS} ${EXPAT_LIBRARY_DIRS} ${FFTW3F_LIBRARY_DIRS} ${GTHREAD_LIBRARY_DIRS} ${GOBJECT_LIBRARY_DIRS}
        ${CANBERRA-GTK_LIBRARY_DIRS})
endif (WIN32)
# create config.h which defines where data are stored
configure_file ("${CMAKE_CURRENT_SOURCE_DIR}/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/config.h")

add_executable (rth ${EXTRA_SRC} ${BASESOURCEFILES})
add_dependencies (rth UpdateInfo)

set_target_properties (rth PROPERTIES COMPILE_FLAGS "${CMAKE_CXX_FLAGS}" OUTPUT_NAME rawtherapee)
#target_link_libraries (rth rtengine ${JPEG_LIBRARIES} ${PNG_LIBRARIES} ${ZLIB_LIBRARIES} ${TIFF_LIBRARIES} ${EXTRA_LIB} ${GOBJECT_LIBRARIES} ${GTHREAD_LIBRARIES}
#   ${GLIB2_LIBRARIES} ${GLIBMM_LIBRARIES} ${GTK_LIBRARIES} ${GTKMM_LIBRARIES} ${GIO_LIBRARIES} ${GIOMM_LIBRARIES} ${LCMS_LIBRARIES} ${IPTCDATA_LIBRARIES})
target_link_libraries (rth rtengine ${JPEG_LIBRARIES} ${PNG_LIBRARIES} ${ZLIB_LIBRARIES} ${TIFF_LIBRARIES} ${GOBJECT_LIBRARIES} ${GTHREAD_LIBRARIES}
   ${GLIB2_LIBRARIES} ${GLIBMM_LIBRARIES} ${GTK_LIBRARIES} ${GTKMM_LIBRARIES} ${GIO_LIBRARIES} ${GIOMM_LIBRARIES} ${LCMS_LIBRARIES} ${EXPAT_LIBRARIES}
   ${FFTW3F_LIBRARIES} ${IPTCDATA_LIBRARIES} ${CANBERRA-GTK_LIBRARIES} ${EXTRA_LIB_RTGUI})
install (TARGETS rth DESTINATION ${BINDIR})

=== debian/changelog ===
rawtherapee-gtk2 (5.0.1-1) mx; urgency=medium

  * Build against gtk 2 version of source, since we don't have the 3.16 version
    of gtk 3 that version requires.
  * Adjust source and package names.
  * Adjust build-depends to gtk 2 versions.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 03 Feb 2017 14:37:08 -0800

rawtherapee (5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Philip Rinn <rinni@inventati.org>  Mon, 23 Jan 2017 16:37:12 +0100

rawtherapee (4.2.1395-1) unstable; urgency=medium

  * New upstream snapshot (closes: #841498).
  * Remove patch patch/01-fix-overflow-in-dcraw.patch:
    - It's applied upstream
  * Bump debhelper compat from 9 to 10 (no changes necessary).
  * Make build reproducible on i386.

 -- Philip Rinn <rinni@inventati.org>  Wed, 16 Nov 2016 23:46:17 +0100

rawtherapee (4.2.1241-2) unstable; urgency=medium

  * Close fixed bugs (closes: #769028, #801540, #822537)
  * Add patch patch/01-fix-overflow-in-dcraw.patch:
    - Fix buffer overflow in dcraw (CVE-2015-8366)

 -- Philip Rinn <rinni@inventati.org>  Fri, 30 Sep 2016 23:16:25 +0200

rawtherapee (4.2.1241-1) unstable; urgency=medium

  * New upstream snapshot:
    - Switch to branch 'gtk3'
  * Remove all patches as they are merged upstream
  * Update build dependencies

 -- Philip Rinn <rinni@inventati.org>  Fri, 30 Sep 2016 21:05:52 +0200

rawtherapee (4.2-5) unstable; urgency=medium

  * Use secure URIs for vcs-* in debian/control.
  * Add patch/06_fix_ftbfs_on_i386-armhf.patch:
    - Use std::abs() in rtefix/rtexif.h
  * Bump Standards-Version to 3.9.8 (no changes necessary).

 -- Philip Rinn <rinni@inventati.org>  Sun, 25 Sep 2016 22:49:38 +0200

rawtherapee (4.2-4) unstable; urgency=medium

  * Add patch/05_fix_build_due_to_unsigned_char.patch:
    - Fix build with C++11 as char is unsigned on some architectures.
      Thanks Gert Wollny for the fix.

 -- Philip Rinn <rinni@inventati.org>  Wed, 04 Nov 2015 16:58:31 +0100

rawtherapee (4.2-3) unstable; urgency=medium

  * Add patch debian/patches/04_fix_build_with_c++11.patch:
    - Fix build with C++11
  * Build with C++11 as glibmm2.4 >= 2.46.1 requires that.
  * Add patch debian/patches/03_fix_build_with_new_sigc++.patch:
    - Fix build with sigc++ >= 2.5.2
  * Remove menu file due to tech-ctte decision on #741573.

 -- Philip Rinn <rinni@inventati.org>  Tue, 03 Nov 2015 18:00:21 +0100

rawtherapee (4.2-2) unstable; urgency=high

  * debian/control: Fix typo in Vcs-Git field
  * Add patch debian/patches/02-fix_CVE-2015-3885.patch:
    - Fix dcraw input sanitization errors (CVE-2015-3885)

 -- Philip Rinn <rinni@inventati.org>  Thu, 14 May 2015 17:41:15 +0200

rawtherapee (4.2-1) unstable; urgency=medium

  * New upstream release:
    - Location of cache and config folder changed again, see NEWS.Debian.
  * Add patch debian/patches/01-fix_build_race-condition.patch:
    - cherry-picked from upstream as build _sometimes_ fails without
  * Bump Standards-Version to 3.9.6 (no changes necessary).

 -- Philip Rinn <rinni@inventati.org>  Sun, 26 Oct 2014 14:00:34 +0200

rawtherapee (4.1-1) unstable; urgency=medium

  * New upstream release:
    - Documentation is removed so we don't need to repack the source anymore.
    - Location of cache and config folder changed. See NEWS.Debian for details. 
  * Drop patch debian/patches/01-AboutThisBuild.patch.

 -- Philip Rinn <rinni@inventati.org>  Sun, 6 Jul 2014 13:14:54 +0200

rawtherapee (4.0.12+dfsg-2) unstable; urgency=medium

  * Install file camconst.json (closes: #737610).

 -- Philip Rinn <rinni@inventati.org>  Wed, 05 Feb 2014 20:05:28 +0100

rawtherapee (4.0.12+dfsg-1) unstable; urgency=low

  * New upstream release:
    - add build dependency g++ (>= 4:4.7) and libgtk2.0-0 (>=2.24.18)
  * Refresh debian/patches/01-AboutThisBuild.patch to apply cleanly.
  * Bump Standards-Version to 3.9.5 (no changes necessary).

 -- Philip Rinn <rinni@inventati.org>  Tue, 14 Jan 2014 16:15:31 +0100

rawtherapee (4.0.11+dfsg-1) unstable; urgency=low

  * New upstream release (closes: #681952, #710534; LP: #1035052):
    - Add build dependency libcanberra-gtk-dev
    - Remove debian/rawtherapee.1 as it's shipped upstream
  * Bump Standards-Version to 3.9.4 (no changes necessary).
  * Update package description (closes: #682657).
  * Refresh debian/patches/01-AboutThisBuild.patch to apply cleanly.
  * Add debian/watch as recommended by Debian Policy Manual section 4.11.
    - Repack the source and document it in debian/README.source

 -- Philip Rinn <rinni@gmx.net>  Wed, 26 Jun 2013 17:57:39 +0200

rawtherapee (4.0.9-4) unstable; urgency=low

  * Fix RC bug that corrupts EXIF data in some cases (closes: #693736):
     - add debian/patches/03-fix_exif_corruption.patch: Use the correct
       size for multibyte EXIF tags which use TagDirectoryTable

 -- Philip Rinn <rinni@gmx.net>  Mon, 19 Nov 2012 21:11:43 +0000

rawtherapee (4.0.9-3) unstable; urgency=low

  * Fix upgrade failure to testing (closes: #677575).
  * Build-depend on libtiff-dev instead of libtiff4-dev.

 -- Philip Rinn <rinni@gmx.net>  Fri, 15 June 2012 10:43:12 +0100

rawtherapee (4.0.9-2) unstable; urgency=low

  * Fix build failures (closes: #677293):
    - use override_dh_install-{arch,indep} in debian/rules
  * Add patch debian/patches/02-fix_color_artifacts.patch:
    - fix color artifacts (from upstream)

 -- Philip Rinn <rinni@gmx.net>  Wed, 13 June 2012 20:01:54 +0100

rawtherapee (4.0.9-1) unstable; urgency=low

  * New upstream release (closes: #662753).
  * Bump Standards-Version to 3.9.3 (no changes necessary).
  * Bump debhelper compat from 8 to 9 (no changes necessary).
  * Enable hardened build flags.
  * Build-depend on libpng-dev instead of libpng12-dev (closes: #662491).
  * Refresh debian/patches/01-AboutThisBuild.patch to apply cleanly.
  * Remove debian/patches/ftbfs-gcc-4.7.diff as it's not needed anymore.
  * Split package as the arch-independent part got bigger.



=== debian/control ===
Source: rawtherapee-gtk2
Section: graphics
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: Philip Rinn <rinni@inventati.org>
Build-Depends:
 cmake,
 debhelper (>= 10),
 imagemagick,
 libbz2-dev,
 libcanberra-gtk-dev,
 libexiv2-dev,
 libexpat1-dev,
 libfftw3-dev,
 libgtk2.0-dev (>=2.12),
 libgtkmm-2.4-dev (>= 2.22),
 libiptcdata0-dev,
 libjpeg-dev,
 liblcms2-dev,
 libpng-dev,
 libsigc++-2.0-dev,
 libtiff-dev,
 zlib1g-dev,
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rawtherapee.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/rawtherapee.git
Homepage: http://www.rawtherapee.com

Package: rawtherapee
Architecture: any
Depends:
 rawtherapee-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: raw image converter and digital photo processor
 RawTherapee is an advanced program for developing raw photos and for processing
 non-raw photos. It is non-destructive, makes use of OpenMP, supports all the
 cameras supported by dcraw and carries out its calculations in a high precision
 32bit floating point engine. RawTherapee supports JPEG, PNG, and TIFF as output
 format for processed photos.
 .
 This version is built using GTK+ 2.

Package: rawtherapee-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 rawtherapee (= ${source:Version}),
Replaces:
 rawtherapee (<< 4.0.9),
Breaks:
 rawtherapee (<< 4.0.9),
Description: raw image converter and digital photo processor (data files)
 RawTherapee is an advanced program for developing raw photos and for processing
 non-raw photos. It is non-destructive, makes use of OpenMP, supports all the
 cameras supported by dcraw and carries out its calculations in a high precision
 32bit floating point engine. RawTherapee supports JPEG, PNG, and TIFF as output
 format for processed photos.
 .
 This package contains the data files.

=== debian/rules ===
#!/usr/bin/make -f

## Enable compiler hardening flags.
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
## Only link with needed libraries
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCREDITSDIR=/usr/share/doc/rawtherapee -DLICENCEDIR=/usr/share/doc/rawtherapee -DPROC_FORCED_LABEL=generic -DCMAKE_CXX_FLAGS="-std=c++11" -DCACHE_NAME_SUFFIX=""

override_dh_install-arch:
	dh_install
	convert -geometry 32x32 rtdata/icons/hi32-app-rawtherapee.png debian/rawtherapee/usr/share/pixmaps/rawtherapee.xpm
	rm debian/rawtherapee/usr/share/doc/rawtherapee/LICENSE.txt

override_dh_install-indep:
	dh_install
	rm debian/rawtherapee-data/usr/share/rawtherapee/languages/LICENSE
